#==============================================================================
# PCIe Link Event Watcher
#==============================================================================
def link_event_watcher(time, event_type):
    if   (event_type == LINK_DETECT):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Detect")
    elif (event_type == LINK_TS1_EXCHANGE):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link TS1 Exchange")
    elif (event_type == LINK_TS2_EXCHANGE):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link TS2 Exchange")
    elif (event_type == LINK_CONFIG_LINKWIDTH):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Config Linkwidth")
    elif (event_type == LINK_CONFIG_LINKWIDTH_ACCEPT):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Config Linkwidth Accept")
    elif (event_type == LINK_CONFIG_COMPLETE):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Config Complete")
    elif (event_type == LINK_CONFIG_IDLE):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Config Idle")
    elif (event_type == LINK_UP):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Up")
    elif (event_type == LINK_RECOVERY_RCVRLOCK):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Recovery Receiver Lock")
    elif (event_type == LINK_RECOVERY_RCVRCFG):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Recovery Receiver Config")
    elif (event_type == LINK_RECOVERY_SPEED):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Recovery Speed")
    elif (event_type == LINK_RECOVERY_IDLE):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Recovery Idle")
    elif (event_type == LINK_FLOW_CONTROL_INIT):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Flow Control Init")
    elif (event_type == LINK_READY):
        sim.imsg("---> [Time " + str(time) + "] PCIe Link Ready")
    else:
        sim.imsg("---> [Time " + str(time) + "] ERROR!!! Unknown PCIe Link Event")

#-------------------------------------------------------------
# wait here until link is ready
#-------------------------------------------------------------
sim.msg("---------------------------------------------------------------------\n"
        "Wait for PCIe Link Ready\n"
        "---------------------------------------------------------------------\n")
# wait until link is ready, or timeout if 5000 clks elapsed
pcie.link_event_wait(LINK_READY, 5000, link_event_watcher)
